{$A-,B-,D+,E-,F-,I-,L+,N-,O-,R-,S+,V-}
{ Pascal implementation. DisYcode procedure. (c) 1989 YGP }

unit Dis; interface
  uses Machine, CFH;

  procedure DisYproc(s: SegmentP; ProcNo: ShortCard);

implementation
  uses DOS, CRT;

  type InstrName = packed array [0..6] of char;

       MnemRec = record
	 name: InstrName;
	 d: byte;
       end; { MnemRec }

  var Mnemo:  array [0..255] of MnemRec;
      LMnemo: array [0..127] of MnemRec;
      SMnemo: array [0.. 63] of MnemRec;
      RMnemo: array [$80..$ff] of MnemRec;

      { descriptor byte: two nybbles
      {   0 - no parm,		1 - unsigned byte
      {   2 - double word,	3 - word
      {   4 - big,		5 - set
      {   6 - relative (word)
      {   7 - relative (byte+)	8 - relative (byte-)
      {   9 -			a - assembly (first nybble)
      {   b -			c -
      {   d -			e -

      {   f - Special (HiNybble)
      {    0 - LYCode		  1 - Std IO proc/func
      {    2 - Real		  3 -
      {    4 -			  5 -
      {    6 -			  7 -
      {    8 -			  9 -
      {    a -			  b -
      {    c -			  d -
      {    e -			  f -				}

  const HexDigits: packed array [0..15] of char = '0123456789abcdef';

  procedure Whex(b: byte);
  begin
  write(HexDigits[HiNybble(b)]); write(HexDigits[LoNybble(b)]);
  end; { Whex }

  (*  :       
            ,  ...
             *)

  procedure DisYproc(s: SegmentP; ProcNo: ShortCard);
    label getkey;
    const MaxPrSz = 4095; {     }
    type Proc = packed record
	   ProcNo: byte;
	   LexLevel: byte;
	   DataSize: word;
	   ParmSize: word;
	   ExitCode: Cardinal;
	 end; { Proc }

	 ProcP = ^Proc;

    var p: ProcP;
	code: MemByteP;
	instr_sz, i: integer;
	ipc, ExitIPC, MaxIPC: Cardinal;
	mnemonic: alpha;
	lb: packed array [0..MaxPrSz] of boolean; { /  }
	LastInstruction: boolean;
	operands: string;

    function GetProcOffset(ProcNo: ShortCard): Cardinal;
    begin
    GetProcOffset:= word(addr(s^.code[s^.PDict + ProcNo * 2])^);
    end; { GetProcOffset }

(*
 ipc  Ycode		labels	mnemo	operands
xxxx: xx xx xx xx xx  | L_llll: aaaaaaa XX, XX, XX, XX
*)

    type str8 = string[8];

    function LabName(ipc: Cardinal): str8;
      var i: byte;
	  l: alpha;
    begin
    FillChar(l, SizeOf(l), ' ');
    if lb[ipc] then
      if ipc = ExitIPC
	then l:= 'exit:   '
	else begin l[0]:= 'L'; l[1]:= '_';
	     Dec(ipc, SizeOf(Proc)); {     }
	     if Hi(ipc) <> 0
	       then begin l[2]:= HexDigits[HiNybble(Hi(ipc))];
		    l[3]:= HexDigits[LoNybble(Hi(ipc))];
		    i:= 4;
		    end
	       else i:= 2;
	     l[i  ]:= HexDigits[HiNybble(ipc)];
	     l[i+1]:= HexDigits[LoNybble(ipc)];
	     l[i+2]:= ':'
	     end;
    LabName:= l;
    end; { LabName }

    function InstrSize(ipc: word): word;
      label Exit;
      var Instr: byte;
	  w, SVipc: word;
	  p1, p2, lp1, lp2: byte;

      procedure DisInitFor;
      begin
      Inc(ipc);
      {  BIG operand }
      Inc(ipc, 1 + ord(code^[ipc] > 127));

      {   byte }
      lp1:= code^[ipc];
      Inc(ipc);
      {         rel+,  rel word }
      if odd(lp1)
	then begin { short jump }
	     lb[ipc - 1 + code^[ipc]]:= true;
	     Inc(ipc);
	     end
	else begin { long jump }
	     Move(code^[ipc], w, 2);
	     lb[ipc-1 + w]:= true;
	     Inc(ipc, 2);
	     end
      end; { DisInitFor }

      procedure Xjump;
	var SvIpc: word;
	    w, rw: word;
	    min, max: word;
      begin
      Inc(ipc);
      {  word (min) }
      Move(code^[ipc], min, 2);
      Inc(ipc, 2);

      {  word (max) }
      Move(code^[ipc], max, 2);
      Inc(ipc, 2);

      {  rel word long jump }
      SvIPC:= ipc;
      Move(code^[ipc], rw, 2);
      lb[SvIpc + rw]:= true;
      Inc(ipc, 2);
      {    array [1..(max-min) + 1] of relword; }
      for w:= 1 to max-min+1 do
	begin Move(code^[ipc], rw, 2);
	if rw <> 0 then lb[SvIpc + rw]:= true;
	Inc(ipc, 2);
	end;
      end; { Xjump }

      procedure Cjump;
	var SvIpc: word;
	    rw: word;
	    w, w1: word;
      begin
      Inc(ipc);
      {  BIG operand }
      SvIPC:= ipc;
      Move(code^[ipc], w, 2);
      if w and $ff < 128
	then w:= w and $ff
	else w:= Swap(w) and $7fff;
      Inc(ipc, 1 + ord(w > 127));
      {  rel word long jump }
      SvIPC:= ipc;
      Move(code^[ipc], rw, 2);
      lb[SvIpc + rw]:= true;
      Inc(ipc, 2);
      {    array [1..big] of (word, relword); }
      for w:= 1 to w do
	begin Inc(ipc, 2);
	Move(code^[ipc], rw, 2);
	lb[SvIpc + rw]:= true;
	Inc(ipc, 2);
	end;
      end; { Cjump }

    begin
    Instr:= code^[ipc];
    SVipc:= ipc;
    p1:= HiNybble(Mnemo[Instr].d);
    p2:= LoNybble(Mnemo[Instr].d);
    if p1 = $f
      then begin { $f: special }
	   Inc(ipc);
	   case p2 of
	     0: with LMnemo[code^[ipc]] do
		  begin
		  lp1:= HiNybble(d);
		  lp2:= LoNybble(d);
		  {    }
		  {   
		           }
		  LastInstruction:= code^[ipc] in [$60..$62];
		  case code^[ipc] of
		    $7f: begin DisInitFor; goto exit; end;

		    $74, { Xjump?, <min>,<max>,<word>,array [1..big] of 4bytes }
		    $75: begin Xjump; goto exit; end;

			 { Cjump?, <big>, <word>, array [1..big] of 4bytes }
		    $77: begin Cjump; goto exit; end;
		    end;
		  end;
	     1: with SMnemo[code^[ipc]] do
		  begin
		  lp1:= HiNybble(d);
		  lp2:= LoNybble(d);
		  end;
	     2: with RMnemo[code^[ipc]] do
		  if code^[ipc] < $80
		    then begin lp1:= 0; lp2:= 0; end
		    else begin lp1:= HiNybble(d);
			 lp2:= LoNybble(d);
			 end;
	     end
	   end
      else with Mnemo[Instr] do
	     begin lp1:= p1; lp2:= p2; end;

    Inc(ipc);
    case lp1 of
      0: goto Exit;

      1: begin lp1:= code^[ipc];
	 Inc(ipc);
	 end; { when 1 }

      2: Inc(ipc,4);

      3: Inc(ipc, 2);

      4: Inc(ipc, 1 + ord(code^[ipc] > 127));

      5: ; { boza ne move da e taka }

      6: begin
	 Move(code^[ipc], w, 2);
	 lb[SVipc + w]:= true;
	 Inc(ipc, 2);
	 end;

      7: begin lb[SVipc + code^[ipc]]:= true;
	 Inc(ipc);
	 end;

      8: begin lb[SVipc + ($ff00 or code^[ipc])]:= true;
	 Inc(ipc);
	 end;
      end; { case }

    case lp2 of
      1: Inc(ipc);

      2: Inc(ipc, 4);

      3: Inc(ipc, 2);

      4: Inc(ipc, 1 + ord(code^[ipc] > 127));

      5: Inc(ipc, lp1); { first parm is size }

      6: begin
	 Move(code^[ipc], w, 2);
	 lb[SVipc + w]:= true;
	 Inc(ipc, 2);
	 end;

      7: begin lb[SVipc + code^[ipc]]:= true;
	 Inc(ipc);
	 end;

      8: begin lb[SVipc + ($ff00 or code^[ipc])]:= true;
	 Inc(ipc);
	 end;
      end; { case }

    Exit: InstrSize:= ipc - SVipc;
    end; { InstrSize }

    function DisOneInstr(ipc: word): word;
      label Exit;
      var Instr: byte;
	  SaveIpc: word; { for relative calcs }
	  p1, p2, lp1, lp2: byte;
	  w: word;

      procedure PutByte(b: byte);
      begin
      Inc(operands[0], 2);
      operands[length(operands) - 1]:= HexDigits[HiNybble(b)];
      operands[length(operands)    ]:= HexDigits[LoNybble(b)];
      end; { PutByte }

      procedure PutWord(w: word);
      begin
      Inc(operands[0], 4);
      operands[length(operands) - 3]:= HexDigits[HiNybble(Hi(w))];
      operands[length(operands) - 2]:= HexDigits[LoNybble(Hi(w))];
      operands[length(operands) - 1]:= HexDigits[HiNybble(w)];
      operands[length(operands)    ]:= HexDigits[LoNybble(w)];
      end; { PutWord }

      procedure DisInitFor;
      begin
      Inc(ipc);
      {  BIG operand }
      Move(code^[ipc], w, 2);
      if w and $ff < 128
	then w:= w and $ff
	else w:= Swap(w) and $7fff;
      PutWord(w);
      Inc(ipc, 1 + ord(w > 127));
      operands:= operands + ', ';
      {   byte }
      lp1:= code^[ipc];
      PutByte(lp1);
      Inc(ipc);
      operands:= operands + ', ';
      {         rel+,  rel word }
      if odd(lp1)
	then begin { short jump }
	     operands:= operands + LabName(ipc-1 + code^[ipc]);
	     Inc(ipc);
	     end
	else begin { long jump }
	     Move(code^[ipc], w, 2);
	     operands:= operands + LabName(ipc-1 + w);
	     Inc(ipc, 2);
	     end
      end; { DisInitFor }

      procedure Xjump;
	var SvIpc: word;
	    w, rw: word;
	    min, max: word;
      begin
      Inc(ipc);
      {  word (min) }
      Move(code^[ipc], min, 2);
      PutWord(min);
      Inc(ipc, 2);
      operands:= operands + ', ';

      {  word (max) }
      Move(code^[ipc], max, 2);
      PutWord(max);
      Inc(ipc, 2);
      operands:= operands + ', ';

      {  rel word long jump }
      SvIPC:= ipc;
      Move(code^[ipc], rw, 2);
      operands:= operands + LabName(SvIpc + rw);
      Inc(ipc, 2);
      {    array [1..(max-min) + 1] of relword; }
      for w:= 1 to max-min+1 do
	begin operands:= operands + ', ';
	Move(code^[ipc], rw, 2);
	if rw <> 0
	  then operands:= operands + LabName(SvIpc + rw)
	  else operands:= operands + '*:';
	Inc(ipc, 2);
	end;
      end; { Xjump }

      procedure Cjump;
	var SvIpc: word;
	    rw: word;
	    w, w1: word;
      begin
      Inc(ipc);
      {  BIG operand }
      SvIPC:= ipc;
      Move(code^[ipc], w, 2);
      if w and $ff < 128
	then w:= w and $ff
	else w:= Swap(w) and $7fff;
      PutWord(w);
      Inc(ipc, 1 + ord(w > 127));
      operands:= operands + ', ';
      {  rel word long jump }
      SvIPC:= ipc;
      Move(code^[ipc], rw, 2);
      operands:= operands + LabName(SvIpc + rw);
      Inc(ipc, 2);
      {    array [1..big] of (word, relword); }
      for w:= 1 to w do
	begin operands:= operands + ', ';
	PutWord(word(addr(code^[ipc])^));
	Inc(ipc, 2);
	operands:= operands + '-';
	Move(code^[ipc], rw, 2);
	operands:= operands + LabName(SvIpc + rw);
	Inc(ipc, 2);
	end;
      end; { Cjump }

    begin
    operands:= '';
    FillChar(mnemonic, sizeof(mnemonic), ' ');

    SaveIPC:= ipc;
    Instr:= code^[ipc];
    p1:= HiNybble(Mnemo[Instr].d);
    p2:= LoNybble(Mnemo[Instr].d);
    if p1 = $f
      then begin { $f: special }
	   Inc(ipc);
	   case p2 of
	     0: with LMnemo[code^[ipc]] do
		  begin
		  lp1:= HiNybble(d);
		  lp2:= LoNybble(d);
		  Move(name, mnemonic, SizeOf(name));
		  case code^[ipc] of
		    $7f: begin DisInitFor; goto exit; end;

		    $74, { Xjump?, <min>,<max>,<word>,array [1..big] of 4bytes }
		    $75: begin Xjump; goto exit; end;

			 { Cjump?, <big>, <word>, array [1..big] of 4bytes }
		    $77: begin Cjump; goto exit; end;
		    end;
		  end;
	     1: with SMnemo[code^[ipc]] do
		  begin
		  lp1:= HiNybble(d);
		  lp2:= LoNybble(d);
		  Move(name, mnemonic, SizeOf(name));
		  end;
	     2: with RMnemo[code^[ipc]] do
		  if code^[ipc] < $80
		    then begin lp1:= 0; lp2:= 0;
			 mnemonic:= 'sldrc   '
			 end
		    else begin Move(name, mnemonic, SizeOf(name));
			 lp1:= HiNybble(d);
			 lp2:= LoNybble(d);
			 end;
	     end
	   end
      else with Mnemo[Instr] do
	     begin lp1:= p1; lp2:= p2;
	     Move(name, mnemonic, SizeOf(name));
	     end;

    Inc(ipc);
    case lp1 of
      0: goto Exit;
      1: begin lp1:= code^[ipc];
	 PutByte(lp1);
	 Inc(ipc);
	 end; { when 1 }
      2: begin PutWord(word(addr(code^[ipc+2])^));
	 PutWord(word(addr(code^[ipc])^));
	 Inc(ipc, 4);
	 end;
      3: begin PutWord(word(addr(code^[ipc])^));
	 Inc(ipc, 2);
	 end;
      4: begin Move(code^[ipc], w, 2);
	 if w and $ff < 128
	   then w:= w and $ff
	   else w:= Swap(w) and $7fff;
	 PutWord(w);
	 Inc(ipc, 1 + ord(w > 127));
	 end;
      5: begin
	 (* Warning('First parm is set?    *.tbl file'); *)
	 end;
      6: begin Move(code^[ipc], w, 2);
	 operands:= operands + LabName(Saveipc + w);
	 Inc(ipc, 2);
	 end;
      7: begin
	 operands:= operands + LabName(Saveipc + code^[ipc]);
	 Inc(ipc);
	 end;
      8: begin
	 operands:= operands + LabName(Saveipc + ($ff00 or code^[ipc]));
	 Inc(ipc);
	 end;
      end; { case }

    if lp2 <> 0 then operands:= operands + ', ';
    case lp2 of
      1: begin PutByte(code^[ipc]);
	 Inc(ipc);
	 end; { when 1 }
      2: begin Move(code^[ipc+2], w, 2);
	 PutWord(w);
	 Move(code^[ipc], w, 2);
	 PutWord(w);
	 Inc(ipc);
	 end;
      3: begin Move(code^[ipc], w, 2);
	 PutWord(w);
	 Inc(ipc, 2);
	 end;
      4: begin Move(code^[ipc], w, 2);
	 if w and $ff < 128
	   then w:= w and $ff
	   else w:= Swap(w) and $7fff;
	 PutWord(w);
	 Inc(ipc, 1 + ord(w > 127));
	 end;
      5: begin operands:= 'set???';
	 Inc(ipc, lp1); { first parm is size }
	 end;
      6: begin Move(code^[ipc], w, 2);
	 operands:= operands + LabName(Saveipc + w);
	 Inc(ipc, 2);
	 end;
      7: begin
	 operands:= operands + LabName(Saveipc + code^[ipc]);
	 Inc(ipc);
	 end;
      8: begin
	 operands:= operands + LabName(Saveipc + ($ff00 or code^[ipc]));
	 Inc(ipc);
	 end;
      end; { case }
    Exit: DisOneInstr:= ipc - SaveIPC;
    end; { DisOneInstr }

    function WriteBytes(Max5: boolean; N: integer): integer;
      label exit;
      var lipc, nn: integer;
    begin
    lipc:= ipc; nn:= 0;
    if not Max5 and (n <> 0) then write('      ');
    while n <> 0 do
      begin
      Whex(code^[lipc]); write(' ');
      Dec(n); inc(lipc); inc(nn);
      if nn mod 5 = 0 then
	if Max5 or (n = 0)
	  then goto exit
	  else begin writeln; write('      '); end;
      end; { while }
exit:
    WriteBytes:= nn;
    if Max5
      then write('': (5 - nn) * 3);
    end; { WriteBytes }

  begin { DisYproc }
  writeln;
  write('procedure ', ProcNo, ' ($'); Whex(ProcNo);
  write('), ');
  p:= addr(s^.code[GetProcOffset(ProcNo)]);
  code:= pointer(p);
  if p^.ProcNo = 0
    then begin writeln('assembly language.');
	 writeln('Can''t disassembly yet.');
	 exit;
	 end;
  if p^.ProcNo <> ProcNo
    then begin writeln(' *** Error in code segment ***');
	 exit;
	 end;
  with p^ do
    begin write('Lex ', LexLevel, ' ($'); Whex(LexLevel);
    write('), Data: ', DataSize, ' ($'); Whex(Hi(DataSize)); Whex(Lo(DataSize));
    write('), Parm: ', ParmSize, ' ($'); Whex(Hi(ParmSize)); Whex(Lo(ParmSize));
    write(')');
    end;
  ExitIPC:= p^.ExitCode;
  FillChar(lb, SizeOf(lb), 0); {     }
  if ExitIPC > MaxPrSz
    then begin writeln('Procedure too long'); exit; end;
  lb[ExitIPC]:= true;
  writeln;
  writeln(' ipc  Ycode             labels  mnemo   operands');

  {           
  {           
  {      ProcDict, Cpool     
  {           boolean  
  {  . }

  { Pass 1 resolve labels }
  ipc:= SizeOf(Proc); LastInstruction:= false;
  repeat Inc(ipc, InstrSize(ipc));
  until LastInstruction;

  { Pass 2 print disYcode}
  MaxIPC:= ipc;
  ipc:= SizeOf(Proc);
  repeat instr_sz:= DisOneInstr(ipc);
    Whex(Hi(ipc - SizeOf(Proc))); Whex(Lo(ipc - SizeOf(Proc))); write(': ');
    i:= WriteBytes(true, instr_sz);
    writeln(' | ', LabName(ipc), mnemonic, operands);
    inc(ipc, i);
    if WriteBytes(false, instr_sz - i) <> 0 then writeln;
    Inc(ipc, instr_sz - i);
    if KeyPressed
      then begin if (ReadKey = #0) and (ReadKey = #0) then;
	   write('Press <any key> to continue or  <esc> to terminate...');
GetKey:    case ReadKey of
	     #0: begin if (ReadKey <> #0) then ;
		 goto GetKey
		 end;
	     #27: exit;
	     end;
	   write(#13); clreol;
	   end;
  until ipc = maxIPC;

  writeln('                                .end procedure ');
  end; { DisYproc }

  procedure InitDisYcode;
    const FName = 'Mnemo.tbl';
    var Err: word;
	Dir: DirStr;
	DOSname: NameStr;
	DOSext: ExtStr;
	f: file;

  begin { InitDisYcode }
  FSplit(ParamStr(0), Dir, DOSname, DOSext);
  { read Ycode instruction mnemonics }
  Assign(f, Dir + Fname);
  reset(f, 1);
  if IOresult <> 0
    then begin Dir:= '\utl\'; assign(f, dir+ fname); reset(f, 1); end;
  if IOresult <> 0
    then begin Write('Can''t find file ', Dir + Fname); halt; end;
  BlockRead(f, Mnemo, SizeOf(Mnemo));
  if IOresult <> 0
    then begin Write('Error reading file ', Dir + Fname); halt; end;
  BlockRead(f, LMnemo, SizeOf(LMnemo));
  if IOresult <> 0
    then begin Write('Error reading file ', Dir + Fname); halt; end;
  BlockRead(f, SMnemo, SizeOf(SMnemo));
  if IOresult <> 0
    then begin Write('Error reading file ', Dir + Fname); halt; end;
  BlockRead(f, RMnemo, SizeOf(RMnemo));
  if IOresult <> 0
    then begin Write('Error reading file ', Dir + Fname); halt; end;
  close(f);
  end; { InitDisYcode }

begin
InitDisYcode;
end. { Dis }
